(* div : int -> int -> (int * int)
 *
 * The call (div m n) returns a pair (q, r) where q is the integer
 * quotient and r is the integer remainder.
*)
let div (m:int) (n:int) : int * int = (m / n, m mod n)

let rec copy item n =
  match n = 0 with
  | true  -> []
  | false -> item::(copy item (n - 1))

let rec largest xs =
  match xs with
  | [] -> failwith "largest: empty list"
  | [item] -> item
  | y::ys -> max y (largest ys)

let rec remove x xs =
  match xs with
  | [] -> []
  | y::ys -> match x = y with
	     | true  -> remove x ys
	     | false -> y::remove x ys

let getLargest ns =
  let big = largest ns
  in
  (big, remove big ns)

let rec change amount coins =
  match amount = 0 with
  | true  -> []
  | false -> 
     let (largestCoin, remainingCoins) = getLargest coins in
     let (numLargest, residual) = div amount largestCoin
     in
     (copy largestCoin numLargest) @ (change residual remainingCoins)
