(* file: 02.1.factorials.ml
   author: Bob Muller

   Three different versions of the factorial
   function. The last one is the best one!
*)
let rec fact (n:int) : int = 
  if n = 0 then 1 else n * fact(n - 1)

let rec fact (n:int) : int =
  match n = 0 with 
  | true  -> 1
  | false -> n * fact(n - 1)

(* The following definition is tail-recursive -- the multipy is being done
   "on the way in" instead of "on the way out".
*)
let fact (n:int) : int =
  let rec loop n acc =
    match n = 0 with
    | true  -> acc
    | false -> loop (n - 1) (n * acc)
  in
  loop n 1
