(* file: 02.1.fibonaccis.ml
   author: Bob Muller

   Two versions of the Fibonacci function. Given an index n, it will
   return the nth element of the sequence:

   0, 1, 1, 2, 3, 5, 8, 13, ...

   The first version is utterly impractical. The second version better.
 *)
let rec fib (n:int) : int =
  match n < 3 with
  | true  -> n - 1
  | false -> fib(n - 1) + fib(n - 2)

let fib (n:int) : int =
  let rec loop n a b =
    match n = 1 with
    | true  -> a
    | false -> loop (n - 1) b (a + b)
  in
  loop n 1 1
