let rec merge xs ys =
  match (xs, ys) with
  | ([], []) -> []
  | (xs, []) -> xs
  | ([], ys) -> ys
  | (x::xs, y::ys) -> (match x < y with
		       | true  -> x::merge xs (y::ys)
		       | false -> y::merge (x::xs) ys)

let split xs =
  let n = List.length xs in
  let rec loop m xs =
    match (m, xs) with
    | (0, _) -> ([], xs)
    | (_, y::ys) -> 
       let (left, right) = loop (m - 1) ys
       in
       (y::left, right)
  in
  loop (n / 2) xs

let rec mergeSort xs =
  match (List.length xs <= 1) with
  | true -> xs
  | _  -> let (left, right) = split xs
	  in
	  merge (mergeSort left) (mergeSort right)
