(* permutations : 'a list -> int -> 'a list list

 The call (permutations syms n) returns all length n permutations 
 of symbols in syms.  For example, the call (permutations [0; 1] 2) 
 returns the list [[0; 0]; [0; 1]; [1; 0]; [1; 1]].
 *)
let rec permutations symbols n =
  match n = 0 with
  | true  -> [[]]
  | false -> let previous = permutations symbols (n - 1) in
	     let oneMore  = List.map
				(fun s -> (List.map (fun p -> s::p) previous))
				symbols
	     in
	     List.fold_left (@) [] oneMore
