let div m n = (m / n, m mod n)
		
(* addDigits : int -> int -> int -> int -> (int * int)
 *
 * The call (addDigits d1 d2 carryIn b) adds base b digits d1 and d2
 * with a carryIn producing the sum and the carryOut.
 *)
let addDigits a b carryIn base =
  let sum = a + b + carryIn in
  let (carryOut, sumDigit) = div sum base
  in
  (sumDigit, carryOut)

(* positionalAdd : int list -> int list -> int -> (int * int)
 *
 * The call (positionalAdd d1s d2s carryIn b) adds base b digits 
 * d1s and d2s with a carryIn producing the sum and the carryOut.
 *)
let positionalAdd ms ns base =
  let rec repeat ms ns carryIn acc =
    match (ms, ns) with
    | ([], []) -> carryIn::acc
    | (m::ms, n::ns) -> let (sum, carryOut) = addDigits m n carryIn base
			in
			repeat ms ns carryOut (sum::acc)
  in
  repeat (List.rev ms) (List.rev ns) 0 []
