let rec partition pivot xs =
  match xs with
  | [] -> ([], [])
  | y::ys -> let (smaller, larger) = partition pivot ys
	     in
	     match y < pivot with
	     | true  -> (y::smaller, larger)
	     | false -> (smaller, y::larger)

let rec quicksort xs =
  match xs with
  | []  -> xs
  | [_] -> xs
  | y::ys -> let (smaller, larger) = partition y ys
	     in
	     (quicksort smaller) @ [y] @ (quicksort larger)
