(* reverse : 'a list -> 'a list
 *
 * The call (reverse xs) returns the result of revesing xs.
 *)
let rec reverse xs =
  match xs with
  | [] -> xs
  | y::ys -> append (reverse ys) [y]

(* Using the built-in append operator.
 *)
let rec reverse xs =
  match xs with
  | [] -> xs
  | y::ys -> (reverse ys) @ [y]

(* The above require quadratic work. The following is linear.
 *)
let reverse xs =
  let rec repeat xs acc =
    match xs with
    | [] -> acc
    | y::ys -> repeat ys (y::acc)
  in
  repeat xs []
