let xor a b = (a || b) && (not (a && b))

let fullAdder a b cin =
  let c = xor a b in
  let sum = xor c cin in
  let carryOut = (a && b) || (c && cin)
  in
  (sum, carryOut)

(* rippleCarryAdder : bool list -> bool list -> bool -> (bool list * bool)
 *
 * The call (rippleCarryAdder ms ns carryIn) implements a ripple carry
 * adder. It is essentially identical to the positionAdd function.
 *)
let rippleCarryAdder ms ns =
  let rec repeat ms ns carryIn acc =
    match (ms, ns) with
    | ([], []) -> (acc, carryIn)
    | (m::ms, n::ns) -> let (sum, carryOut) = fullAdder m n carryIn
			in
			repeat ms ns carryOut (sum::acc)
    | _ -> failwith "Hmm: the lists were supposed to be equal length"
  in
  repeat (List.rev ms) (List.rev ns) false []
