(* file: worlddemo.ml
   author: Bob Muller

   A simple demo of the World module graphics system.
 *)
open Color
open Image
open World
open Cs1101

let displayWidth = 600.
let displayHeight = displayWidth
  
let draw _ =
  let empty_image = empty_scene displayWidth displayHeight in
  let horizontalStripe = rectangle displayWidth 300. Color.orange in
  let verticalStripe = rectangle 300. displayHeight Color.blue in 
  let myCircle = circle 150. Color.red in 
  let image1 = place_image horizontalStripe (0., 0.) empty_image in
  let image2 = place_image verticalStripe   (0., 0.) image1 
  in
    place_image myCircle (300., 300.) image2

let test () : unit =
  big_bang ()
           ~name:"Simple Universe Demo"
           ~width:(f2I displayWidth)
           ~height:(f2I displayHeight)
           ~to_draw:draw

let _ = test()
